import os

import rq

from app.mission_jobs.image_slice import slice_zxy
from config import Config
from connection import Connection


def image_slice_job(data_path, output_path, tile_size, tile_grid, tile_format, auto_zoom, min_zoom, max_zoom):
    config = Config()
    connection = Connection(config)

    # 添加任务
    q = rq.Queue(name='default', connection=connection.redis_conn)
    for file_name in os.listdir(data_path):
        input_file = os.path.join(data_path, file_name)
        if os.path.splitext(file_name)[-1] == ".tif":
            q.enqueue(slice_zxy,
                      kwargs={"input_file": input_file,
                              "output_path": output_path,
                              "tile_size": tile_size,
                              "tile_grid": tile_grid,
                              "tile_format": tile_format,
                              "auto_zoom": auto_zoom,
                              "min_zoom": min_zoom,
                              "max_zoom": max_zoom},
                      job_timeout=int(config.common.JOB_TIMEOUT)
                      )
